
/* Written by Peter Ekberg, peda@lysator.liu.se */

#ifndef THRUST_H
#define THRUST_H

/* DEBUG  will make you undestructible.
   DEBUG2 gives you some trace output. */

/*#define DEBUG*/
/*#define DEBUG2*/

/* The speed of the game. Gravity and thrust is affected.
   Don't try too large values. 256 is what it used to
   be in the good old days. */

#define SPEED 180

/* Uncomment the following define if you have an old version of
   svgalib (i.e version < 1.2.8) */
/*
#define SCANCODE_P 25
*/


/* How many levels and what they are named. */

#define LEVELS (6)
extern char *level1[];
extern char *level2[];
extern char *level3[];
extern char *level4[];
extern char *level5[];
extern char *level6[];


#include <vgagl.h>
#include "thrust_types.h"

typedef enum { INST, PLAY, HI, ABOUT, END, KEYS, NOTHING, DEMO } options;

extern unsigned int title_nr_colors;
extern unsigned int title_cols, title_rows;
extern unsigned char title_colors[];
extern unsigned char title_pixels[];
extern unsigned char bin_blocks[];
extern unsigned char bin_ship[];
extern unsigned char bin_shield[];
extern unsigned char bin_colors[];
extern unsigned char bin_bullets[];
extern unsigned char bin_demomoves[];

extern byte *bulletmap;
extern Palette *palette;
extern byte *blocks;
extern byte *ship;
extern byte *shieldship;
extern byte *bana;
extern byte *fuelmap;
extern byte *loadmap;
extern byte *shipstorage;
extern byte *bulletstorage;
extern byte *fragmentstorage;
extern byte *fuelstorage;
extern byte *loadstorage;
extern byte *wirestorage;

extern word lenx; /* Banans max i x-len, anvnds senare till den aktuella */
extern word leny; /* Banans max i y-len, storleken p banan.Stts i readbana */
extern word lenx3,leny3;

extern int alpha,deltaalpha;
extern word loaded,loadcontact,loadpointshift;
extern int loadpoint;
extern int countdown;
extern word crash,shoot,repetetive;
extern word refueling;
extern int speedx,speedy;
extern long absspeed,oldabs;
extern int kdir,dir;
extern int shipdx,shipdy;
extern int x,y;
extern int pixx,pixy;
extern int pblockx,pblocky;
extern int vx,vy;
extern int bildx,bildy;
extern int bblockx,bblocky;
extern int loadbx,loadby;
extern int gravity;
extern int score;
extern byte shield;
extern byte colorr, colorg, colorb;


int insideblock(int blockx, int blocky,
		int pblockx, int pblocky, int sx, int sy);
int insidepixel(int x, int y, int pixx, int pixy, int sx, int sy);
void updateborder(int pblockx, int pblocky,
		  int bblockx, int bblocky, int vx, int vy);
void fade_in(void);
void fade_out(void);
void pause_message(void);
void escape_message(void);
byte whatkeys(void);
byte nextmove(int reset);
int game(int demo);
void pressanykey(void);
int instructions(void);
int about(void);
char *enterhighscorename(void);
int showhighscores(void);
void newhighscore(void);
options menu(void);
/*
extern void putscr(int x,int y);
extern void putblock(int x, int y, byte *source);
extern void writeblock(word bx, word by, byte block);
extern void drawship(word bx, word by, byte *ship, byte *storage);
extern void undrawship(word bx, word by, byte *storage);
extern void drawsquare(word bx, word by,
		       byte *object, byte *storage, byte deltax, byte deltay);
extern void undrawsquare(word bx, word by,
			 byte *storage, byte deltax, byte deltay);
extern word testcrash(byte *object, byte *storage, word len, byte shield);
extern void fadepalette(word first, word last, Palette *RGBtable,
			word fade, word flag);
extern void setmargin(byte color, byte flag);

void drawfuel(int fuel);
void savegraphics(int x, int y);

int inithighscorelist(void);
char *standardname(void);
int ahighscore(int score);
void inserthighscore(char *name, int score);
void writehighscores(void);
*/
#endif /* THRUST_H */
